/**************************************************************\
* Copyright (C) 1997 - 2001 Vasile CALMATUI (vasile@wook.com)  *
*                                                              *
* This software is public domain. Permission is granted to     *
* use, copy and modify this software to anyone.                *
****************************************************************
* Please don't contact me for information, bugs, comments, job *
* offers. If you like this software, please send a postcard to *
* the following address:                                       *
* Vasile CALMATUI                                              *
* 35 str. Burebista                                            *
* 3600 Ungheni                                                 *
* MOLDOVA                                                      *
****************************************************************
* The author is not liable for damages resulting from  the use *
* of this software or its derivates.                           *
\**************************************************************/

import java.applet.Applet;
import java.awt.*;
import java.util.*;
import java.io.*;

public class VasObfuLite extends Applet {
  //applet stuff
  Label lState;
  TextArea taContents;
  Button bGo;
  //to move from one TextField to another using tabkey
  Component[] compo;

  //we are working as command line or in a applet
  boolean isApplet=true;

  //what's the line separtor of the current system (\r\n or just \n)
  String lineSep=new String(System.getProperty("line.separator"));

  //array with "known java classes" (1.02)
  String[] classes={"VasOnglets", "VasTabs", "AbstractMethodError", "Applet", "AppletContext", "AppletStub", "ArithmeticException", "ArrayIndexOutOfBoundsException", "ArrayStoreException", "AudioClip", "AWTError", "AWTException", "BitSet", "Boolean", "BorderLayout", "BufferedInputStream", "BufferedOutputStream", "Button", "ByteArrayInputStream", "ByteArrayOutputStream", "Canvas", "CardLayout", "Character", "Checkbox", "CheckboxGroup", "CheckboxMenuItem", "Choice", "Class", "ClassCastException", "ClassCircularityError", "ClassFormatError", "ClassLoader", "ClassNotFoundException", "Cloneable", "CloneNotSupportedException", "Color", "ColorModel", "Compiler", "Component", "Container", "ContentHandler", "ContentHandlerFactory", "CropImageFilter", "DatagramPacket", "DatagramSocket", "DataInput", "DataInputStream", "DataOutput", "DataOutputStream", "Date", "Dialog", "Dictionary", "Dimension", "DirectColorModel", "Double", "EmptyStackException", "Enumeration", "EOFException", "Error", "Event", "Exception", "File", "FileDescriptor", "FileDialog", "FileInputStream", "FilenameFilter", "FileNotFoundException", "FileOutputStream", "FilteredImageSource", "FilterInputStream", "FilterOutputStream", "Float", "FlowLayout", "Font", "FontMetrics", "Frame", "Graphics", "GridBagConstraints", "GridBagLayout", "GridLayout", "Hashtable", "IllegalAccessError", "IllegalAccessException", "IllegalArgumentException", "IllegalMonitorStateException", "IllegalThreadStateException", "Image", "ImageConsumer", "ImageFilter", "ImageObserver", "ImageProducer", "IncompatibleClassChangeError", "IndexColorModel", "IndexOutOfBoundsException", "InetAddress", "InputStream", "Insets", "InstantiationError", "InstantiationException", "Integer", "InternalError", "InterruptedException", "InterruptedIOException", "IOException", "Label", "LayoutManager", "LineNumberInputStream", "LinkageError", "List", "Long", "MalformedURLException", "Math", "MediaTracker", "MemoryImageSource", "Menu", "MenuBar", "MenuComponent", "MenuContainer", "MenuItem", "NegativeArraySizeException", "NoClassDefFoundError", "NoSuchElementException", "NoSuchFieldError", "NoSuchMethodError", "NoSuchMethodException", "NullPointerException", "Number", "NumberFormatException", "Object", "Observable", "Observer", "OutOfMemoryError", "OutputStream", "Panel", "PipedInputStream", "PipedOutputStream", "PixelGrabber", "PlainSocketImpl", "Point", "Polygon", "PrintStream", "Process", "Properties", "ProtocolException", "PushbackInputStream", "Random", "RandomAccessFile", "Rectangle", "RGBImageFilter", "Runnable", "Runtime", "RuntimeException", "Scrollbar", "SecurityException", "SecurityManager", "SequenceInputStream", "ServerSocket", "Socket", "SocketException", "SocketImpl", "SocketImplFactory", "SocketInputStream", "SocketOutputStream", "Stack", "StackOverflowError", "StreamTokenizer", "String", "StringBuffer", "StringBufferInputStream", "StringIndexOutOfBoundsException", "StringTokenizer", "System", "TextArea", "TextComponent", "TextField", "Thread", "ThreadDeath", "ThreadGroup", "Throwable", "Toolkit", "UnknownError", "UnknownHostException", "UnknownServiceException", "UnsatisfiedLinkError", "URL", "URLConnection", "URLEncoder", "URLStreamHandler", "URLStreamHandlerFactory", "UTFDataFormatException", "Vector", "VerifyError", "VirtualMachineError", "Window"};

  //array with all reserved words
  String[] keywords={"abstract", "boolean", "break", "byte", "byvalue", "case", "catch", "char", "class", "const", "continue", "default", "do", "double", "else", "extends", "false", "final", "finally", "float", "for", "goto", "if", "implements", "import", "instanceof", "int", "interface", "long", "native", "new", "null", "package", "private", "protected", "public", "return", "short", "static", "super", "switch", "synchronized", "this", "threadsafe", "throw", "transient", "true", "try", "void", "while"};

  //array with all data types
  String[] types={"boolean", "byte", "char", "double", "float", "int", "long", "short"};

  //"dictionnary" to change words
  Hashtable privateVariables=new Hashtable();

  //"dictionnary" of public vars, not to change
  Hashtable publicVariables=new Hashtable();

  //"dictionnary" of unknown words, not to change
  Hashtable unknownWords=new Hashtable();

  Vector allTokens=new Vector();
  Vector tokenType=new Vector();
  int isWord=0;
  int isSpace=1;
  int isString=2;
  int isComment1=3;
  int isComment2=4;
  int isChar=5;

  int isKeyword=6;
  int isKeywordPublic=7;
  int isKeywordThis=8;

  int isKeywordTypeOfData=9;
  int isKnownJavaClass=10;

  int isPrivateVariable=11;
  int isPublicVariable=12;

  int isNumber=13;

  int isUnknown=14;

  //used to name the variables, like
  //v0, v1, ...
  int varNum=0;

  //array of separators
  char[] separators={' ', '\r', '\n', '\t', ';', ',', '(', ')', '{', '}', '=', '<', '>', '-', '+', '*', '/', '%', '^', '!', '?', '|', '&', ':', '~', '[', ']', '\''};
  //array of all figures
  char[] figures={'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f', 'x', '.', 'l'};

  //information about the applet
  public String getAppletInfo() {
    return (new String("VasObfuLite v0.9 February 14th, 1999, (C) 1997, 1998, 1999, 2000, 2001 Vasile Calmatui"));
  }//end getAppletInfo

  //function called in command line mode
  public static void main(String[] args) {
    VasObfuLite myClass=new VasObfuLite(false);
    boolean toForce=false;
    if(args.length==0) {
      System.out.println("usage: VasObfuLite [-f] file1 file2 ..\n-f option overrides the existing files.");
      System.exit(1);
    }

    for(int i=0; i<args.length; i++) {
      //verifying if -f argument was passed
      if(args[i].equals("-f")) {
        toForce=true;
        continue;
      }//end if
      try {
          String fileContent;
          String newFile=new String(args[i]+".vas");
          RandomAccessFile file=new RandomAccessFile(args[i], "r");
          //slurping the source file in the memory
          {
            byte[] fileC=new byte[(int)file.length()];
            file.readFully(fileC);
            file.close();
            fileContent=new String(fileC, 0);
          }//end slurp
          //does the file already exists
          {
            File newOne=new File(newFile);
            if(newOne.exists()) {
              if(toForce) {
                newOne.delete();
              }//end if
              else {
                System.out.println("File "+newFile+" already exists.\nYou can use -f option to override it.");
                System.exit(-1);
              }//end else
            }//end if
          }//end file test
          //writing the new HTML file
          file=new RandomAccessFile(newFile, "rw");
          file.writeBytes(myClass.transform(fileContent));
          file.close();
      }//end try
      catch(Exception e) {
        System.out.println("File problem");
        e.printStackTrace(System.out);
        System.exit(-1);
      }//end catch
    }//end for
  }//fin main

  //constructor for command line version
  public VasObfuLite(boolean isApplet) {
    this.isApplet=isApplet;
  }//end constructor for command line version

  //constructor for applet version
  public VasObfuLite() {
    setLayout(null);
    setFont(new Font("Courier", Font.PLAIN, 12));
    setBackground(Color.lightGray);
    lState=new Label("Paste in TextArea your Java code and make Go!");
    lState.reshape(10, 10, 360, 25);
    add(lState);

    bGo=new Button("Go!");
    bGo.reshape(385, 10, 70, 30);
    add(bGo);

    taContents=new TextArea();
    taContents.reshape(20, 45, 435, 210);
    add(taContents);
    taContents.appendText("/* (C), vasile@wook.com */"
                          +lineSep+"import java.awt.*;"
                          +lineSep+lineSep+"public class VasTest {"
                          +lineSep+"  int hex=0x32;"
                          +lineSep+"  public int integ=32;//remains unchanged"
                          +lineSep+"  int OCTAL=077;"
                          +lineSep+"  float floatN=.13f;"
                          +lineSep+"  String string=\"String\";"
                          +lineSep+"}//end VasTest");
    resize(470, 340);
  }//end constructor for applet version

  //function called by the browser after the constructor
  public void init() {
    compo=new Component[2];
    compo[0]=taContents;
    compo[1]=bGo;
    compo[0].requestFocus();
    if(compo[0] instanceof TextComponent) ((TextComponent)compo[0]).selectAll();
  }//end init

  //main function for transforming the names of Java identifiers
  String transform(String toTransform){
    //to see in how much time it was performed
    Date dBegin=new Date();

    //cleaning the Hashtables and the Vectors
    //if there's already something
    if(allTokens.size()>0) {
      privateVariables=new Hashtable();
      publicVariables=new Hashtable();
      allTokens=new Vector();
      tokenType=new Vector();
    }//end if

    //where begins the current word
    int iBegWord=0;
    //the type of the current word
    int thisWordType=isWord;
    //true if a word is finished, false otherwise
    boolean bEndWord=false;

    //if we have a space first
    if(isSeparator(toTransform.charAt(0))) {
      thisWordType=isSpace;
      bEndWord=true;
    }//end if

    //the length of the String to transform
    int strLength=toTransform.length();

    //scanning each character and transforming it in Vector of String
    for(int i=0; i<strLength; i++) {
      if(isApplet && i%100==0) lState.setText("Analyzing character "+i+"/"+strLength);
      //current character
      char cCurr=toTransform.charAt(i);
      switch(cCurr) {
        //to mark the strings
      case '\"' : {
        //storing it in allTokens
        allTokens.addElement(toTransform.substring(iBegWord, i));
        tokenType.addElement(new Integer(thisWordType));
        int oldI=i;
        i=getEndOfType(toTransform, i+1, "\"");
        //storing it in allTokens
        allTokens.addElement(toTransform.substring(oldI, i));
        tokenType.addElement(new Integer(isString));
        iBegWord=i;
        break;
      }//end case "
        //to mark the chars
      case '\'' : {
        //storing it in allTokens
        allTokens.addElement(toTransform.substring(iBegWord, i));
        tokenType.addElement(new Integer(thisWordType));
        int oldI=i;
        i=getEndOfType(toTransform, i+1, "'");
        //storing it in allTokens
        allTokens.addElement(toTransform.substring(oldI, i));
        tokenType.addElement(new Integer(isChar));
        iBegWord=i;
        break;
      }//end case '
      //to mark the comments
      case '*' : {
        if(i!=0 && toTransform.charAt(i-1)=='/') {
          //storing it in allTokens
          allTokens.addElement(toTransform.substring(iBegWord, i-1));
          tokenType.addElement(new Integer(thisWordType));
          int oldI=i-1;
          i=getEndOfType(toTransform, i, "*/");
          //storing it in allTokens
          allTokens.addElement(toTransform.substring(oldI, i));
          tokenType.addElement(new Integer(isComment1));
          iBegWord=i;
          break;
        }//end if
      }//end *
      case '/' : {
        if(i!=0 && toTransform.charAt(i-1)=='/') {
          //storing it in allTokens
          allTokens.addElement(toTransform.substring(iBegWord, i-1));
          tokenType.addElement(new Integer(thisWordType));
          int oldI=i-1;
          i=getEndOfType(toTransform, i, "\n");
          //storing it in allTokens
          allTokens.addElement(toTransform.substring(oldI, i));
          tokenType.addElement(new Integer(isComment2));
          iBegWord=i;
          break;
        }//end if
      }//end /
      default : {
        boolean sep=isSeparator(cCurr);
        if(bEndWord!=sep) {
          //storing it in allTokens
          allTokens.addElement(toTransform.substring(iBegWord, i));
          tokenType.addElement(new Integer(thisWordType));
          //it's the beginning of a new word
          iBegWord=i;
          //it's changing
          bEndWord=!bEndWord;
        }//end if
        if(sep) thisWordType=isSpace;
        else thisWordType=isWord;
        break;
      }//end default
      }//end switch i
    }//end for

    //adding the last element
    allTokens.addElement(toTransform.substring(iBegWord));
    tokenType.addElement(new Integer(thisWordType));

    //analyzing all the Tokens
    for(int i=0; i<allTokens.size(); i++) {
      if(((Integer)tokenType.elementAt(i)).intValue()==isWord) tokenType.setElementAt(new Integer(analyzeToken(i)), i);
    }//end for

    StringBuffer result=new StringBuffer("/*"+lineSep+"  This file was \"LiteObfuscated\" by VasObfuLite."+lineSep+"  For more information visit http://www.chez.com/vasile/obfu/VasObfuLite.html"+lineSep+"  (C) 1999, 2000 Vasile Calmatui"+lineSep+"*/"+lineSep);

    int tkSize=allTokens.size();
    for(int i=0; i<tkSize; i++) {
      int type=((Integer)tokenType.elementAt(i)).intValue();
      String value=(String)allTokens.elementAt(i);
      if(type==isPrivateVariable) value=findName(value);
      result.append(value);
    }//end for

    if(isApplet) lState.setText("Completed in "+((new Date()).getTime()-dBegin.getTime()) + " millisec. "+result.length()+" characters.");

    return result.toString();
  }//end transform

  //analyzing the token
  //looks if it's not a reserved keyword
  //returns the type of the token
  int analyzeToken(int pos) {
    String thisWord=(String)allTokens.elementAt(pos);
    //invalid
    if(thisWord.length()<1) return isSpace;

    //looking if it's not a number
    //if it begins with a letter, then it's not a number
    //even not with a, b, c, d, e, f, x, l
    //a identifier cannot start with a figure,
    //but can start with "."
    {
      char c=thisWord.charAt(0);
      if((c>='0' && c<='9') || (c=='.' && thisWord.length()>1 && thisWord.charAt(1)>='0' && thisWord.charAt(1)<='9')) return isNumber;
    }//end looking if it's not a number

    //treating special case of "something.whatever"
    //splitting the word
    {
      int nextDot=thisWord.indexOf('.');
      //if it's something like myVar.something
      if(nextDot>0) {
        allTokens.insertElementAt(thisWord.substring(nextDot+1), pos+1);
        tokenType.insertElementAt(new Integer(isWord), pos+1);
        allTokens.insertElementAt(".", pos+1);
        tokenType.insertElementAt(new Integer(isSpace), pos+1);
        thisWord=new String(thisWord.substring(0, nextDot));
        allTokens.setElementAt(thisWord, pos);
      }//end if
    }//end splitting the word

    //looking if it's a keyword
    for(int i=0; i<keywords.length; i++) {
      if(thisWord.equals(keywords[i])) {
        if(keywords[i].equals("public")) return isKeywordPublic;
        if(keywords[i].equals("this")) return isKeywordThis;
        //if this keyword is a dataType, then mark it
        for(int k=0; k<types.length; k++) {
          if(keywords[i].equals(types[k])) return isKeywordTypeOfData;
        }//end for
        return isKeyword;
      }//end if
    }//end for
    //looking if it's a "known Java class"
    for(int i=0; i<classes.length; i++) {
      if(thisWord.equals(classes[i])) return isKnownJavaClass;
    }//end for

    //already in privateVariables?
    if(privateVariables.containsKey(thisWord)) {
      //if it's something like System.out.println
      //when out is a already defined variable
      if((pos-2)>0 && ((String)allTokens.elementAt(pos-1)).equals(".") && !(((String)allTokens.elementAt(pos-2)).equals("this"))) return isUnknown;
      allTokens.setElementAt((String)privateVariables.get(thisWord), pos);
      return isPrivateVariable;
    }//end if

    //already in isPublic?
    if(publicVariables.containsKey(thisWord)) return isPublicVariable;

    //is this the name of a function?
    //yes, if it has parens after the name
    boolean isFunction=spaceHasParens(pos);

    //is this word a public variable?
    if(isPublic(pos) && !isFunction) {
      publicVariables.put(thisWord, thisWord);
      return isPublicVariable;
    }//end if

    //it's not a keyword, not a number, not a JavaClass, then it can
    //be a custom keyword, if it's not function-like and
    //if is not defined before
    if(previousWordWasDataType(pos) && !isFunction) {
      privateVariables.put(thisWord, thisWord);
      return isPrivateVariable;
    }//end if

    //unknown
    unknownWords.put(thisWord, thisWord);
    return isUnknown;
  }//end analyzeToken

  //was the previous word a DataType?
  boolean previousWordWasDataType(int pos) {
    //scanning all the tokens before this position
    while(--pos>0) {
      int type=((Integer)tokenType.elementAt(pos)).intValue();
      //keep on analyzing, just comments
      if(type==isComment1 || type==isComment2) continue;
      else {
        if(type==isKnownJavaClass || type==isKeywordTypeOfData || type==isPrivateVariable) return true;
        if(type==isSpace) {
          //only whitespace, comma and [] allowed here
          String myWord=(String)allTokens.elementAt(pos);
          int strLength=myWord.length();
          for(int i=0; i<strLength; i++) {
            char c=myWord.charAt(i);
            if(!(c==' ' || c==',' || c=='\t' || c=='[' || c==']')) return false;
          }//end for
          continue;
        }//end if
        return false;
      }//end else
    }//end while
    return false;
  }//end previousWordWasDataType

  //has the space after this position a parens, ie it's a function?
  boolean spaceHasParens(int pos) {
    //scanning all the tokens after this position
    while(++pos<tokenType.size()) {
      int type=((Integer)tokenType.elementAt(pos)).intValue();
      //keep on analyzing, just comments
      if(type==isComment1 || type==isComment2) continue;
      else {
        if(type==isSpace) {
          //only whitespace allowed here
          String myWord=(String)allTokens.elementAt(pos);
          int strLength=myWord.length();
          for(int i=0; i<strLength; i++) {
            char c=myWord.charAt(i);
            if(c==' ' || c=='\t') continue;
            if(c=='(') return true;
            return false;
          }//end for
        }//end if
        return false;
      }//end else
    }//end while
    return false;
  }//end spaceHasParens

  //find the name for a Variable, and if it can, change it
  String findName(String oldName) {
    //dont put new names for public variables
    //or unknown ones
    if(publicVariables.containsKey(oldName) || unknownWords.containsKey(oldName)) return oldName;

    String now=(String)privateVariables.get(oldName);
    if(now.equals(oldName)) {
      now=findNewVarName();
      privateVariables.put(oldName, now);
    }
    return now;
  }//end findName

  //find a new name for a Variable
  String findNewVarName() {
    StringBuffer newN=new StringBuffer();
    if(varNum>676) newN.append((char)('a'+varNum/676));
    if(varNum>26) newN.append((char)('a'+varNum/26));
    newN.append((char)('a'+varNum%26));

    String newName=newN.toString();
    varNum++;
    //it can also be:
    //String newName=new String("v"+(varNum++));

    //can I use this newName?, ie:
    //already this variable in privateVariables?
    //already this variable in isPublic?
    //looks then for another name
    if(privateVariables.containsKey(newName) || publicVariables.containsKey(newName) || privateVariables.contains(newName)) return findNewVarName();
    return newName;
  }//end findNewVarName

  //is this word public
  boolean isPublic(int pos) {
    //scanning all the tokens before this position
    while(--pos>0) {
      int type=((Integer)tokenType.elementAt(pos)).intValue();
      //keep on analyzing, just comments
      if(type==isComment1 || type==isComment2) continue;
      else {
        if(type==isPublicVariable || type==isKeywordPublic) return true;
        if(type==isKeyword || type==isKnownJavaClass || type==isKeywordTypeOfData) continue;
        if(type==isSpace) {
          //only whitespace, comma and [] allowed here
          String myWord=(String)allTokens.elementAt(pos);
          int strLength=myWord.length();
          for(int i=0; i<strLength; i++) {
            char c=myWord.charAt(i);
            if(!(c==' ' || c==',' || c=='\t' || c=='[' || c==']')) return false;
          }//end for
          continue;
        }//end if
        return false;
      }//end else
    }//end while
    return false;
  }//end isPublic

  //is this characterer escaped?
  //ie "\\n" is not escaped
  boolean isNotEscaped(String myString, int charPosition) {
    int i=1;
    for(; (charPosition-i)>=0; i++) {
      if(myString.charAt(charPosition-i)!='\\') break;
    }//end for
    if(i%2==0) return false;
    return true;
  }//isNotEscaped

  //is this character a separator?
  boolean isSeparator(char car) {
    for(int i=0; i<separators.length; i++) {
      if(car==separators[i]) return true;
    }//end for
    return false;
  }//end isSeparator

  //in the string myString searches for the first occurence
  //on unescape whatStops
  int getEndOfType(String myString, int where, String whatStops) {
    int strLength=myString.length();
    int whatLength=whatStops.length();
    //looking for the string whatStops
    while(where<(strLength-whatLength)) {
      int j=0;
      while(j<whatLength && myString.charAt(where+j)==whatStops.charAt(j)) {j++;}
      if(j==whatLength && isNotEscaped(myString, where)) {
        where+=whatLength;
        break;
      }//end if
      where++;
    }//end while
    //if arrived at the end of the file
    if(where==strLength-whatLength) where+=whatLength;
    return where;
  }//end getEndOfType

  public boolean handleEvent(Event e) {
    //to move from one TextField to another using tabkey
    if(e.id==Event.KEY_PRESS && e.key == '\t') {
      for(int i=0; i<compo.length; i++) {
        if(e.target==compo[i]) {
          //in IE4, the text remains selected
          //it's not cute, so deselect it before going away
          if(compo[i] instanceof TextComponent) ((TextComponent)compo[i]).select(0, 0);
          //if a component is disabled, we go further
          do {
            i=(i+(e.shiftDown() ? compo.length-1 : 1))%compo.length;
          } while (!compo[i].isEnabled());
          compo[i].requestFocus();
          if(compo[i] instanceof TextComponent) ((TextComponent)compo[i]).selectAll();
          return true;
        }//end if
      }//end for
      return false;
    }//end '\t'

    if(e.target==bGo && (e.arg==bGo.getLabel() || (e.id==Event.KEY_RELEASE && e.key=='\n'))) {
      //transforming and putting the text
      taContents.setText(transform(taContents.getText()));
      return true;
    }//end if
    return false;//other events will not be proceded
  }//end handleEvent
}//end class VasObfuLite
